#include <windows.h>
#include "GamePad.h"
#include <sqobject/sqratfunc.h>

// ͏(SIuWFNg)
int GamePad::state     = 0;
int GamePad::prevState = 0;
int GamePad::tstate    = 0;
int GamePad::rstate    = 0;

/**
 * RXgN^
 */
GamePad::GamePad()
{
};

/**
 * fXgN^
 */
GamePad::~GamePad()
{
}

/**
 * @param key ΏۃL[
 * @return Ă邩
 */
bool
GamePad::isPress(int key)
{
	return (state & key) != 0;
}

/**
 * @param key ΏۃL[
 * @return ꂽuԂ
 */
bool
GamePad::isTrigger(int key)
{
	return (tstate & key) != 0;
}

/**
 * @param key ΏۃL[
 * @return Ă邩
 */
bool
GamePad::isRelease(int key)
{
	return (rstate & key) != 0;
}

// L[
struct KeyInfo {
	int key;
	int vkey;
};
static KeyInfo keyinfos[] = {
	{PAD_SELECT, VK_RETURN},
	{PAD_CANCEL, VK_ESCAPE},
	{PAD_UP,     VK_UP},
	{PAD_RIGHT,  VK_RIGHT},
	{PAD_DOWN,   VK_DOWN},
	{PAD_LEFT,   VK_LEFT},
};

/**
 * ꂽL[PԂiDxj
 * @return ꂽL[
 */
int
GamePad::getKey()
{
	for (int i=0;i<sizeof(keyinfos)/sizeof(keyinfos[0]);i++) {
		KeyInfo *info = keyinfos + i;
		if (isTrigger(info->key)) {
			return info->key;
		}
	}
	return 0;
}

/**
 * ԍXVp
 */
void
GamePad::update()
{
	prevState = state;
	// ͏ԍXV
	if (GetFocus() != NULL) {
		state = 0;
		for (int i=0;i<sizeof(keyinfos)/sizeof(keyinfos[0]);i++) {
			KeyInfo *info = keyinfos + i;
			if (::GetAsyncKeyState(info->vkey) & 0x8000) {
				state |= info->key;
			}
		}
	}
	tstate = (~prevState & state);  // gK
	rstate = ~(prevState & ~state); // [X
}

/**
 * NXo^
 */
void
GamePad::registerClass()
{
	HSQUIRRELVM vm = sqobject::getGlobalVM();
	Sqrat::DerivedClass<GamePad, sqobject::Object, sqobject::DefaultConstructor<GamePad>> cls(vm);
	SQFUNC(GamePad, isPress);
	SQFUNC(GamePad, isTrigger);
	SQFUNC(GamePad, isRelease);
	SQFUNC(GamePad, getKey);
	// sqrat  set/get ㏑ sqobject @\ƐƂ
	sqobject::OverrideSetGet<GamePad>::Func(vm);
	Sqrat::RootTable(vm).Bind(_SC("GamePad"), cls);
}
